"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var rspack_exports = {};
__export(rspack_exports, {
  DEFAULT_BABEL_PRESET_TYPESCRIPT_OPTIONS: () => DEFAULT_BABEL_PRESET_TYPESCRIPT_OPTIONS,
  applyRspackBabelConfig: () => applyRspackBabelConfig
});
module.exports = __toCommonJS(rspack_exports);
var import_shared = require("@rsbuild/shared");
var import_lodash = require("lodash");
const DEFAULT_BABEL_PRESET_TYPESCRIPT_OPTIONS = {
  allowNamespaces: true,
  allExtensions: true,
  allowDeclareFields: true,
  // aligns Babel's behavior with TypeScript's default behavior.
  // https://babeljs.io/docs/en/babel-preset-typescript#optimizeconstenums
  optimizeConstEnums: true,
  isTSX: true
};
const applyRspackBabelConfig = (api, userOptions) => {
  api.modifyBundlerChain(
    async (chain, { CHAIN_ID, isProd, getCompiledPath }) => {
      const config = api.getNormalizedConfig();
      const getBabelOptions = (config2) => {
        const includes2 = [];
        const excludes2 = [];
        const babelUtils = {
          addIncludes(items) {
            if (Array.isArray(items)) {
              includes2.push(...items);
            } else {
              includes2.push(items);
            }
          },
          addExcludes(items) {
            if (Array.isArray(items)) {
              excludes2.push(...items);
            } else {
              excludes2.push(items);
            }
          }
        };
        const baseConfig = {
          plugins: [],
          presets: [
            // TODO: only apply preset-typescript for ts file (isTSX & allExtensions false)
            [
              require.resolve("@babel/preset-typescript"),
              DEFAULT_BABEL_PRESET_TYPESCRIPT_OPTIONS
            ]
          ]
        };
        const userBabelConfig = (0, import_shared.applyUserBabelConfig)(
          (0, import_lodash.cloneDeep)(baseConfig),
          userOptions,
          babelUtils
        );
        const babelOptions2 = {
          babelrc: false,
          configFile: false,
          compact: isProd,
          ...userBabelConfig
        };
        return {
          babelOptions: babelOptions2,
          includes: includes2,
          excludes: excludes2
        };
      };
      const {
        babelOptions,
        includes = [],
        excludes = []
      } = getBabelOptions(config);
      const rule = chain.module.rule(CHAIN_ID.RULE.JS);
      includes.forEach((condition) => {
        rule.include.add(condition);
      });
      excludes.forEach((condition) => {
        rule.exclude.add(condition);
      });
      rule.test((0, import_shared.mergeRegex)(import_shared.JS_REGEX, import_shared.TS_REGEX)).use(CHAIN_ID.USE.BABEL).after(CHAIN_ID.USE.SWC).loader(getCompiledPath("babel-loader")).options(babelOptions);
    }
  );
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  DEFAULT_BABEL_PRESET_TYPESCRIPT_OPTIONS,
  applyRspackBabelConfig
});
